/* take options passed to pain during program execution */

#include <stdio.h>
#include <stdlib.h> /* for atoi() or malloc() */
#include <string.h> /* for strlen() or strcpy() or strcmp() */
#include "./strint.h"
#include "./options.h"

OPTIONS options;

/** return the index of an option, if the option isnt found return 0 **/
int getArg(char *opt)
{
  int i=0;

  for (i=0; i<options.opts; i++)
    if (strcmp(options.opt[i],opt)==0)
      return i;

  return -1;
}

/* retrieve all options and supplied arguments */
void getOptions(int args, char *arg[])
{
  uint i=0;
  uint dash=0;

  options.opts=0;
  options.opt = (char**)malloc(args * sizeof(char*));
  options.arg = (char**)malloc(args * sizeof(char*));

  /** check options and parameters **/
  for (i=1; i<args; i++) /* skip the executable file argument "shade", and switch arguments */
  {
    /** Get Option **/

    /* how many dashes were supplied? */
    dash=0;
    if (arg[i][0] == '-')
    {
      dash=1;
      if (arg[i][1] == '-')
        dash=2;
    }

    /* allocate enough space to hold the switch */
    options.opt[options.opts] = (char*)malloc((strlen(arg[i])-dash+1) * sizeof(char)); /* make room for option */

    /* get the sitch */
    mid(arg[i], dash, strlen(arg[i])-dash, options.opt[options.opts]);

    /* get the argument */
    if (i+1<args) /* if there are more switches or there is an argument passed */
    {
      options.arg[options.opts] = (char*)malloc((strlen(arg[i+1])+2)*sizeof(char)); /* make room for argument */

//      //* if this is a switch that does not need an argument, don't look for one. */
//      if (strcmp(options.opt[options.opts], "R") == 0 || strcmp(options.opt[options.opts], "f") == 0)
//      {
//        strcpy(options.arg[options.opts], "1");           /* mark it 1 */
//      }else{
        strcpy(options.arg[options.opts],arg[i+1]);         /* copy the argument */
        i++;
//      }
    }else{
      options.arg[options.opts] = (char*)malloc(1 * sizeof(char)); /* enough room for nullchar */
      options.arg[options.opts][0] = '\0';                  /* and nullchar it */
    }

    options.opts++;  /* thats one more option we have found */
  }
  return;
}

/** free all malloc()ed variavles in our 'options' structure **/
void freeOptions(void)
{
  int i=0;

  for (i=0; i<options.opts; i++)
  {
    free(options.opt[i]);
    free(options.arg[i]);
  }

  free(options.opt);
  free(options.arg);

  return;
}
