/* functions that deal with strings and integers (and various other data types) */
/* some functions intentionally mimic corresponding Visual BASIC functions */

#include <stdlib.h> /* for atoi() or malloc() */
#include <string.h> /* for strlen() or strcpy() or strcmp() */
#include <ctype.h>  /* for toupper() */

#include "./types.h"
#include "./bits.h"
#include "./strint.h"

/* Integer to String.
   Converts any integer up to 9 digits in length to a
   string, positive or negative. If you get an 'e' somewhere
   in your string, you probably passed an invalid integer. */
void int2str(char *str, int num)
{
  uint i=0,len=0,over=10;
  uint isNegative=0;

  /* we need to figure out how many digits are in our number... */
  len=intlen(num);

  for (i=0; i < (len-2); i++) /* if the number is greater >= 100 */
    over*=10; /* basically: if num is 2 digits long, 'over' is already initiated to 10.
                                      3 ...................... 100
                                      4 ...................... 1000
                                                 etc...           */

  if (num < 0) /* is the number negative? */
  {
    isNegative=TRUE; /* remember that it's a negative number */
    num=-num; /* make the number positive */
  }

// for some reason this just doesnt work
//  /* make sure the string can hold that many numbers! */
//  if (strlen(str) <= len+isNegative) /* and a space for the null terminator and a negative sign too if neccessary */
//    str=realloc(&str, sizeof(char) * len);

  /* add a negative sign if neccssary, and initiate i for the for loop below */
  if (isNegative=TRUE)
  {
    str[0]='-';
    i=1; /* skip the negative sign */
  }else{
    i=0; /* start at zero :-) */
  }

  if (len == 1) /* the number is one digit. very easy. */
  {
    str[0]=int2char(num);
    str[1]='\0'; /* and we add a peso! */
  }else{
    for (/* i is initiated above */; i < len; i++)
    {
      str[i] = int2char(num/over); /* to get only the far left number, we use this equation */

      while (num > over) /* get rid of the digit we already copied with our 'over' variable, */
        num-=(over);     /* which is explained below                                         */

      over=over/10; /*  the variable 'over' is used to subtract one from the far left variable.
                        we need to make sure that each time we make our number decreased in size,
                        we need to fix this var so it does not exceed the size of our number */
    }
  }
  str[1]='\0'; /* and we add a peso! */

  return;
}

/* Integer to Char
   Get an integer, return it as a char */
uchar int2char(int num)
{
  if (num < 0 || num > 9) return '0';
  return (num + 48);
}

/* Integer Length
   Returns the length of an integer up to 9 digits long,
   Returns 10 if we can't figure it out */
uint intlen(int num)
{
  bool neg=FALSE;
  uint len=0, i=0;

  if (num < 0) /* is the number negative? */
  {
    neg=TRUE; /* remember that it's a negative number */
    num=-num; /* make the number positive */
  }

  /* bet ya never saw one of these before! */
  for(i=10, len=1; num/i >= 1; i*=10, len++);

  if (neg == TRUE)
    num=-num; /* restore the number to negative */

  return len; /* return length of number */
}


/* String to Uppercase */
void ucase(char *str)
{
  uint i, len;

  len=strlen(str);

  for (i=0; i < len; i++)
    str[i] = toupper(str[i]);

  return;
}


/* String to Lowercase. */
void lcase(char *str)
{
  uint i, len;

  len=strlen(str);

  for (i=0; i < len; i++)
    str[i] = tolower(str[i]);

  return;
}

/* String Extract */
void mid(char *string, uint start, uint length, char *str0)
{
  uint i=0, len;

  len = strlen(str0);

// for some reason this just doesnt work
//  /* its gotta be big enough */
//  if (len < length)
//    str0=realloc(&str0, (sizeof(char) * (length-len))+1); /* resize it, and add one for a null char */

  for (i=0; i<length; i++)
  {
    if (i < start+length-1) /* subtract 1 because we include the first char in the string. abcde start 3, length 3 would be cde, abcde is length 5, but start+length would be 6 */
      str0[i] = string[i+start];
    else /* no more room for string, we copied all that we could! */
      break;
  }

  str0[i]='\0';

  return;
}

/* Char to Integer*/
uint char2int(uchar byte)
{
  uchar str[2];

  str[0]=byte;
  str[1]='\0'; /* atoi() accepts only strings */

  return atoi((char*)str);

// old method
//  if (byte >= 48 && byte <= 57)
//    return (byte - 48);
//  else
//    return 0; /* what else can we do? */
//
//  return 0; /* will never get here, but just because it feels wrong not to put a return at the end of a function :-) */
}
